#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_FishRankRankingCFG.h"
std::auto_ptr<Fish_FishRankRankingCFG> Fish_FishRankRankingCFG::msSingleton(nullptr);

int Fish_FishRankRankingCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_FishRankRankingCFGData* Fish_FishRankRankingCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_FishRankRankingCFGData>& Fish_FishRankRankingCFG::GetMapData()
{
	return mMapData;
}

void Fish_FishRankRankingCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_FishRankRankingCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_FishRankRankingCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		{
			const char* RewardItme = element->Attribute("RewardItme");
			std::vector<std::string> vecRewardItme;
			boost::split(vecRewardItme, RewardItme, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItme.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItme[i].c_str(), &temp))
				{
					data.mRewardItme.push_back(temp);
				}
			}
		}
		{
			const char* RewardCount = element->Attribute("RewardCount");
			std::vector<std::string> vecRewardCount;
			boost::split(vecRewardCount, RewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardCount[i].c_str(), &temp))
				{
					data.mRewardCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_FishRankRankingCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_FishRankRankingCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_FishRankRankingCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_FishRankRankingCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_FishRankRankingCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "StartRank", data.mStartRank);
		LuaCfgHelper::readInt(L, "EndRank", data.mEndRank);
		LuaCfgHelper::readVectorInt(L, "RewardItme", data.mRewardItme);
		LuaCfgHelper::readVectorInt(L, "RewardCount", data.mRewardCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_FishRankRankingCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_FishRankRankingCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_FishRankRankingCFG* Fish_FishRankRankingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_FishRankRankingCFG());
	}
	return msSingleton.get();
}

void Fish_FishRankRankingCFG::Release()
{
	msSingleton.reset(nullptr);
}
